Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 3346)
+++ /palm/trunk/SOURCE/Makefile	(revision 3347)
@@ -25,4 +25,10 @@
 # -----------------
 # $Id$
+# Add module for offline nesting;
+# Add surface_mod to synthetic-turbulence generator;
+# Bugfix, missing dependency for turbulence generator in init_3d_model;
+# Some formatting ajdustments
+# 
+# 3343 2018-10-15 10:38:52Z suehring
 # (from branch resler)
 # Add biometeorology
@@ -566,4 +572,5 @@
 	netcdf_data_input_mod.f90 \
 	netcdf_interface_mod.f90 \
+	nesting_offl_mod.f90 \
 	ocean_mod.f90 \
 	outflow_turbulence.f90 \
@@ -1005,4 +1012,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	nesting_offl_mod.o \
 	ocean_mod.o \
 	plant_canopy_model_mod.o \
@@ -1036,4 +1044,5 @@
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
+	nesting_offl_mod.o \
 	ocean_mod.o \
 	plant_canopy_model_mod.o \
@@ -1045,4 +1054,5 @@
 	surface_layer_fluxes_mod.o \
 	surface_mod.o \
+	synthetic_turbulence_generator_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o \
@@ -1112,5 +1122,4 @@
 	mod_kinds.o \
 	modules.o \
-	netcdf_data_input_mod.o \
 	surface_mod.o
 local_stop.o: \
@@ -1288,4 +1297,10 @@
 	urban_surface_mod.o \
 	uv_exposure_model_mod.o
+nesting_offl_mod.o: \
+        cpulog_mod.o \
+        mod_kinds.o \
+	modules.o \
+	netcdf_data_input_mod.o \
+	surface_mod.o
 ocean_mod.o: \
 	advec_s_pw.o \
@@ -1335,4 +1350,5 @@
 	modules.o \
 	multi_agent_system_mod.o \
+	nesting_offl_mod.o \
 	netcdf_interface_mod.o \
 	ocean_mod.o \
@@ -1577,5 +1593,7 @@
 	mod_kinds.o \
 	modules.o \
-	pmc_interface_mod.o
+	nesting_offl_mod.o \
+	pmc_interface_mod.o \
+	surface_mod.o
 temperton_fft_mod.o: \
 	mod_kinds.o \
@@ -1600,4 +1618,5 @@
 	modules.o \
 	multi_agent_system_mod.o \
+	nesting_offl_mod.o \
 	ocean_mod.o \
 	pmc_interface_mod.o \
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 3346)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 3347)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in setting boundary conditions in offline nesting
+! 
+! 3341 2018-10-15 10:31:27Z suehring
 ! changes concerning modularization of ocean option
 ! 
@@ -293,5 +296,5 @@
 !
 !-- Vertical nesting: Vertical velocity not zero at the top of the fine grid
-    IF (  .NOT.  child_domain  .AND.                                           &
+    IF (  .NOT.  child_domain  .AND.  .NOT.  nesting_offline  .AND.            &
                  TRIM(coupling_mode) /= 'vnested_fine' )  THEN
        w_p(nzt:nzt+1,:,:) = 0.0_wp  !< nzt is not a prognostic level (but cf. pres)
@@ -729,6 +732,4 @@
 !-- in case of nest boundaries. This must not be done in case of vertical nesting 
 !-- mode as in that case the lateral boundaries are actually cyclic. 
-!-- @todo: Is this really needed? Boundary values will be overwritten in 
-!--        coupler or by Inifor data.
     IF ( nesting_mode /= 'vertical'  .OR.  nesting_offline )  THEN
        IF ( bc_dirichlet_s )  THEN
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 3346)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 3347)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Remove offline nesting in if clause for pressure top boundary condition
+! 
+! 3343 2018-10-15 10:38:52Z suehring
 ! (from branch resler)
 ! Add biometeorology,
@@ -1954,6 +1957,5 @@
        ibc_p_t = 0
 !-- TO_DO: later set bc_p_t to neumann before, in case of nested domain
-    ELSEIF ( bc_p_t == 'neumann' .OR. bc_p_t == 'nested'  .OR.                 &
-             bc_p_t == 'nesting_offline'  )  THEN
+    ELSEIF ( bc_p_t == 'neumann' .OR. bc_p_t == 'nested' )  THEN
        ibc_p_t = 1
     ELSE
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 3346)
+++ /palm/trunk/SOURCE/header.f90	(revision 3347)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Header output concerning offline nesting
+! 
+! 3343 2018-10-15 10:38:52Z suehring
 ! call of ocean_header
 ! 
@@ -438,4 +441,7 @@
     USE netcdf_interface,                                                      &
         ONLY:  netcdf_data_format, netcdf_data_format_string, netcdf_deflate
+        
+    USE nesting_offl_mod,                                                      &
+        ONLY:  nesting_offl_header
 
     USE ocean_mod,                                                             &
@@ -903,4 +909,8 @@
 !-- Large scale forcing and nudging
     IF ( large_scale_forcing )  CALL lsf_nudging_header( io )
+    
+!
+!-- Offline nesting 
+    IF ( nesting_offline )  CALL nesting_offl_header( io )
 
 !
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 3346)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 3347)
@@ -25,4 +25,12 @@
 ! -----------------
 ! $Id$
+! - Separate offline nesting from large_scale_nudging_mod
+! - Improve the synthetic turbulence generator
+! 
+! 3298 2018-10-02 12:21:11Z kanani
+! Minor formatting (kanani)
+! Added CALL to the chem_emissions module (Russo)
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! allocate and set stokes drift velocity profiles
 ! 
@@ -563,4 +571,7 @@
         ONLY:  chem_emis, chem_emis_att, init_3d,                              &
                netcdf_data_input_init_3d, netcdf_data_input_interpolate
+        
+    USE nesting_offl_mod,                                                      &
+        ONLY:  nesting_offl_init
 
     USE ocean_mod,                                                             &
@@ -601,6 +612,7 @@
 
     USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  stg_init, use_syn_turb_gen
-
+        ONLY:  parametrize_inflow_turbulence, stg_adjust, stg_init,            &
+               use_syn_turb_gen
+               
     USE surface_layer_fluxes_mod,                                              &
         ONLY:  init_surface_layer_fluxes
@@ -2152,7 +2164,7 @@
     IF ( nudging )  CALL nudge_init
 !
-!-- Initialize 1D/3D offline-nesting with COSMO model and read data from 
-!-- external file.
-    IF ( large_scale_forcing  .OR.  nesting_offline )  CALL lsf_init
+!-- Initialize 1D large-scale forcing and nudging and read data from external
+!-- ASCII file
+    IF ( large_scale_forcing )  CALL lsf_init
 !
 !-- Initialize surface forcing corresponding to large-scale forcing. Therein, 
@@ -2163,4 +2175,8 @@
        ENDIF
     ENDIF
+!
+!-- Initializae 3D offline nesting in COSMO model and read data from 
+!-- external NetCDF file.
+    IF ( nesting_offline )  CALL nesting_offl_init
 !
 !-- Initialize quantities for special advections schemes
@@ -2279,5 +2295,12 @@
        CALL location_message( 'finished', .TRUE. )
     ENDIF
-
+!
+!-- In case the synthetic turbulence generator does not have any information
+!-- about the inflow turbulence, these information will be parametrized 
+!-- depending on the initial atmospheric conditions and surface properties.
+!-- Please note, within pre-determined time intervals these turbulence 
+!-- information can be updated if desired. 
+    IF ( use_syn_turb_gen  .AND.  parametrize_inflow_turbulence )              &
+       CALL stg_adjust
 !
 !-- If required, set chemical emissions
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 3346)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 3347)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in setting number of ghost layers in neutral case 
+! 
+! 3341 2018-10-15 10:31:27Z suehring
 ! unused variables removed
 ! 
@@ -723,5 +726,5 @@
 ! 
 !-- Determine the number of ghost point layers
-    IF ( ( scalar_advec == 'ws-scheme' .AND. .NOT. neutral ) .OR.             &
+    IF ( scalar_advec   == 'ws-scheme'  .OR.                                   &
          momentum_advec == 'ws-scheme' )  THEN
        nbgp = 3
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3346)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3347)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Assign real value instead of integer
+! 
+! 3341 2018-10-15 10:31:27Z suehring
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -2781,7 +2784,7 @@
                          vegetation_type_f%var(j,i)                 = 1 ! bare soil
                          soil_type_f%var_2d(j,i)                    = 1 
-                         surface_fraction_f%frac(ind_veg_wall,j,i)  = 1
-                         surface_fraction_f%frac(ind_pav_green,j,i) = 0
-                         surface_fraction_f%frac(ind_wat_win,j,i)   = 0
+                         surface_fraction_f%frac(ind_veg_wall,j,i)  = 1.0_wp
+                         surface_fraction_f%frac(ind_pav_green,j,i) = 0.0_wp
+                         surface_fraction_f%frac(ind_wat_win,j,i)   = 0.0_wp
                       ENDIF
                       
